<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>JavaClassImportDeclaration xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/java/codegen/xtend/JavaClassImportDeclaration.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2006 - 2016 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *     Shuai Li (CEA LIST) &lt;shuai.li@cea.fr&gt; - initial API and implementation</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.java.codegen.xtend;
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">import</strong> com.google.common.base.Objects;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> java.util.ArrayList;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.UniqueEList;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EClass;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.base.GenUtils;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.codegen.utils.JavaGenUtils;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.profile.PapyrusJava.ExternLibrary;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.profile.PapyrusJava.External;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.profile.PapyrusJava.Template;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Enumeration;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Interface;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Namespace;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.UMLFactory;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.UMLPackage;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.util.UMLUtil;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  @SuppressWarnings(<span class="jxr_string">"all"</span>)
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/codegen/xtend/JavaClassImportDeclaration.html">JavaClassImportDeclaration</a> {
<a class="jxr_linenumber" name="L36" href="#L36">36</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> List&lt;String&gt; javaClassImports(<strong class="jxr_keyword">final</strong> NamedElement ne, <strong class="jxr_keyword">final</strong> Namespace ns) {
<a class="jxr_linenumber" name="L37" href="#L37">37</a>      List&lt;String&gt; result = <strong class="jxr_keyword">new</strong> ArrayList&lt;String&gt;();
<a class="jxr_linenumber" name="L38" href="#L38">38</a>      <strong class="jxr_keyword">boolean</strong> _hasStereotypeTree = GenUtils.hasStereotypeTree(ne, ExternLibrary.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L39" href="#L39">39</a>      <strong class="jxr_keyword">if</strong> (_hasStereotypeTree) {
<a class="jxr_linenumber" name="L40" href="#L40">40</a>        ExternLibrary _applicationTree = GenUtils.&lt;ExternLibrary&gt;getApplicationTree(ne, ExternLibrary.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L41" href="#L41">41</a>        EList&lt;String&gt; _imports = _applicationTree.getImports();
<a class="jxr_linenumber" name="L42" href="#L42">42</a>        result = _imports;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>      } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L44" href="#L44">44</a>        String _importName = JavaClassImportDeclaration.importName(ne, ns);
<a class="jxr_linenumber" name="L45" href="#L45">45</a>        result.add(_importName);
<a class="jxr_linenumber" name="L46" href="#L46">46</a>      }
<a class="jxr_linenumber" name="L47" href="#L47">47</a>      <strong class="jxr_keyword">return</strong> result;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>    }
<a class="jxr_linenumber" name="L49" href="#L49">49</a>    
<a class="jxr_linenumber" name="L50" href="#L50">50</a>    <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <em class="jxr_javadoccomment">   * @param ne the element to import</em>
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <em class="jxr_javadoccomment">   * @param ns the element in which we import ne</em>
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <em class="jxr_javadoccomment">   */</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String importName(<strong class="jxr_keyword">final</strong> NamedElement ne, <strong class="jxr_keyword">final</strong> Namespace ns) {
<a class="jxr_linenumber" name="L55" href="#L55">55</a>      <strong class="jxr_keyword">boolean</strong> _hasStereotypeTree = GenUtils.hasStereotypeTree(ne, Template.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L56" href="#L56">56</a>      <strong class="jxr_keyword">if</strong> (_hasStereotypeTree) {
<a class="jxr_linenumber" name="L57" href="#L57">57</a>        Template _stereotypeApplication = UMLUtil.&lt;Template&gt;getStereotypeApplication(ne, Template.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L58" href="#L58">58</a>        <strong class="jxr_keyword">return</strong> _stereotypeApplication.getDeclaration();
<a class="jxr_linenumber" name="L59" href="#L59">59</a>      } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L60" href="#L60">60</a>        <strong class="jxr_keyword">boolean</strong> _hasStereotypeTree_1 = GenUtils.hasStereotypeTree(ne, External.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L61" href="#L61">61</a>        <strong class="jxr_keyword">if</strong> (_hasStereotypeTree_1) {
<a class="jxr_linenumber" name="L62" href="#L62">62</a>          External _stereotypeApplication_1 = UMLUtil.&lt;External&gt;getStereotypeApplication(ne, External.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L63" href="#L63">63</a>          <strong class="jxr_keyword">return</strong> _stereotypeApplication_1.getName();
<a class="jxr_linenumber" name="L64" href="#L64">64</a>        } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L65" href="#L65">65</a>          EList&lt;Element&gt; _ownedElements = ns.getOwnedElements();
<a class="jxr_linenumber" name="L66" href="#L66">66</a>          <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">final</strong> Element element : _ownedElements) {
<a class="jxr_linenumber" name="L67" href="#L67">67</a>            <strong class="jxr_keyword">boolean</strong> _or = false;
<a class="jxr_linenumber" name="L68" href="#L68">68</a>            <strong class="jxr_keyword">boolean</strong> _or_1 = false;
<a class="jxr_linenumber" name="L69" href="#L69">69</a>            <strong class="jxr_keyword">if</strong> ((element instanceof Enumeration)) {
<a class="jxr_linenumber" name="L70" href="#L70">70</a>              _or_1 = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L71" href="#L71">71</a>            } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L72" href="#L72">72</a>              _or_1 = (element instanceof Interface);
<a class="jxr_linenumber" name="L73" href="#L73">73</a>            }
<a class="jxr_linenumber" name="L74" href="#L74">74</a>            <strong class="jxr_keyword">if</strong> (_or_1) {
<a class="jxr_linenumber" name="L75" href="#L75">75</a>              _or = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L76" href="#L76">76</a>            } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L77" href="#L77">77</a>              EClass _eClass = element.eClass();
<a class="jxr_linenumber" name="L78" href="#L78">78</a>              UMLPackage _uMLPackage = UMLFactory.eINSTANCE.getUMLPackage();
<a class="jxr_linenumber" name="L79" href="#L79">79</a>              EClass _<strong class="jxr_keyword">class</strong>_ = _uMLPackage.getClass_();
<a class="jxr_linenumber" name="L80" href="#L80">80</a>              <strong class="jxr_keyword">boolean</strong> _equals = _eClass.equals(_<strong class="jxr_keyword">class</strong>_);
<a class="jxr_linenumber" name="L81" href="#L81">81</a>              _or = _equals;
<a class="jxr_linenumber" name="L82" href="#L82">82</a>            }
<a class="jxr_linenumber" name="L83" href="#L83">83</a>            <strong class="jxr_keyword">if</strong> (_or) {
<a class="jxr_linenumber" name="L84" href="#L84">84</a>              String _name = ((Classifier) element).getName();
<a class="jxr_linenumber" name="L85" href="#L85">85</a>              String _name_1 = ne.getName();
<a class="jxr_linenumber" name="L86" href="#L86">86</a>              <strong class="jxr_keyword">boolean</strong> _equals_1 = _name.equals(_name_1);
<a class="jxr_linenumber" name="L87" href="#L87">87</a>              <strong class="jxr_keyword">if</strong> (_equals_1) {
<a class="jxr_linenumber" name="L88" href="#L88">88</a>                <strong class="jxr_keyword">return</strong> <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L89" href="#L89">89</a>              }
<a class="jxr_linenumber" name="L90" href="#L90">90</a>            }
<a class="jxr_linenumber" name="L91" href="#L91">91</a>          }
<a class="jxr_linenumber" name="L92" href="#L92">92</a>          Namespace classifier = ns;
<a class="jxr_linenumber" name="L93" href="#L93">93</a>          Element _owner = ns.getOwner();
<a class="jxr_linenumber" name="L94" href="#L94">94</a>          <strong class="jxr_keyword">boolean</strong> _not = (!(_owner instanceof org.eclipse.uml2.uml.Package));
<a class="jxr_linenumber" name="L95" href="#L95">95</a>          <strong class="jxr_keyword">if</strong> (_not) {
<a class="jxr_linenumber" name="L96" href="#L96">96</a>            Classifier _packagedClassifier = JavaClassImportDeclaration.getPackagedClassifier(ns);
<a class="jxr_linenumber" name="L97" href="#L97">97</a>            classifier = _packagedClassifier;
<a class="jxr_linenumber" name="L98" href="#L98">98</a>            <strong class="jxr_keyword">boolean</strong> _equals_2 = Objects.equal(classifier, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L99" href="#L99">99</a>            <strong class="jxr_keyword">if</strong> (_equals_2) {
<a class="jxr_linenumber" name="L100" href="#L100">100</a>             <strong class="jxr_keyword">return</strong> <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L101" href="#L101">101</a>           }
<a class="jxr_linenumber" name="L102" href="#L102">102</a>         }
<a class="jxr_linenumber" name="L103" href="#L103">103</a>         EList&lt;String&gt; importsOfClassifier = JavaGenUtils.imports.get(classifier);
<a class="jxr_linenumber" name="L104" href="#L104">104</a>         <strong class="jxr_keyword">boolean</strong> _equals_3 = Objects.equal(importsOfClassifier, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L105" href="#L105">105</a>         <strong class="jxr_keyword">if</strong> (_equals_3) {
<a class="jxr_linenumber" name="L106" href="#L106">106</a>           UniqueEList&lt;String&gt; _uniqueEList = <strong class="jxr_keyword">new</strong> UniqueEList&lt;String&gt;();
<a class="jxr_linenumber" name="L107" href="#L107">107</a>           importsOfClassifier = _uniqueEList;
<a class="jxr_linenumber" name="L108" href="#L108">108</a>           JavaGenUtils.imports.put(classifier, importsOfClassifier);
<a class="jxr_linenumber" name="L109" href="#L109">109</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L110" href="#L110">110</a>           <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">final</strong> String <strong class="jxr_keyword">import</strong>_ : importsOfClassifier) {
<a class="jxr_linenumber" name="L111" href="#L111">111</a>             {
<a class="jxr_linenumber" name="L112" href="#L112">112</a>               <strong class="jxr_keyword">final</strong> String[] parts = <strong class="jxr_keyword">import</strong>_.split(<span class="jxr_string">"&#92;&#92;."</span>);
<a class="jxr_linenumber" name="L113" href="#L113">113</a>               <strong class="jxr_keyword">int</strong> _length = parts.length;
<a class="jxr_linenumber" name="L114" href="#L114">114</a>               <strong class="jxr_keyword">boolean</strong> _greaterThan = (_length &gt; 0);
<a class="jxr_linenumber" name="L115" href="#L115">115</a>               <strong class="jxr_keyword">if</strong> (_greaterThan) {
<a class="jxr_linenumber" name="L116" href="#L116">116</a>                 <strong class="jxr_keyword">int</strong> _length_1 = parts.length;
<a class="jxr_linenumber" name="L117" href="#L117">117</a>                 <strong class="jxr_keyword">int</strong> _minus = (_length_1 - 1);
<a class="jxr_linenumber" name="L118" href="#L118">118</a>                 <strong class="jxr_keyword">final</strong> String lastPart = parts[_minus];
<a class="jxr_linenumber" name="L119" href="#L119">119</a>                 String _name_2 = ne.getName();
<a class="jxr_linenumber" name="L120" href="#L120">120</a>                 <strong class="jxr_keyword">boolean</strong> _equals_4 = _name_2.equals(lastPart);
<a class="jxr_linenumber" name="L121" href="#L121">121</a>                 <strong class="jxr_keyword">if</strong> (_equals_4) {
<a class="jxr_linenumber" name="L122" href="#L122">122</a>                   <strong class="jxr_keyword">return</strong> <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L123" href="#L123">123</a>                 }
<a class="jxr_linenumber" name="L124" href="#L124">124</a>               }
<a class="jxr_linenumber" name="L125" href="#L125">125</a>             }
<a class="jxr_linenumber" name="L126" href="#L126">126</a>           }
<a class="jxr_linenumber" name="L127" href="#L127">127</a>         }
<a class="jxr_linenumber" name="L128" href="#L128">128</a>         <strong class="jxr_keyword">final</strong> String qName = GenUtils.getFullName(ne, <span class="jxr_string">"."</span>, false);
<a class="jxr_linenumber" name="L129" href="#L129">129</a>         importsOfClassifier.add(qName);
<a class="jxr_linenumber" name="L130" href="#L130">130</a>         <strong class="jxr_keyword">return</strong> qName;
<a class="jxr_linenumber" name="L131" href="#L131">131</a>       }
<a class="jxr_linenumber" name="L132" href="#L132">132</a>     }
<a class="jxr_linenumber" name="L133" href="#L133">133</a>   }
<a class="jxr_linenumber" name="L134" href="#L134">134</a>   
<a class="jxr_linenumber" name="L135" href="#L135">135</a>   <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> Classifier getPackagedClassifier(<strong class="jxr_keyword">final</strong> Element ns) {
<a class="jxr_linenumber" name="L136" href="#L136">136</a>     <strong class="jxr_keyword">if</strong> ((ns instanceof Classifier)) {
<a class="jxr_linenumber" name="L137" href="#L137">137</a>       <strong class="jxr_keyword">return</strong> ((Classifier) ns);
<a class="jxr_linenumber" name="L138" href="#L138">138</a>     } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L139" href="#L139">139</a>       Element _owner = ns.getOwner();
<a class="jxr_linenumber" name="L140" href="#L140">140</a>       <strong class="jxr_keyword">boolean</strong> _equals = Objects.equal(_owner, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L141" href="#L141">141</a>       <strong class="jxr_keyword">if</strong> (_equals) {
<a class="jxr_linenumber" name="L142" href="#L142">142</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L143" href="#L143">143</a>       }
<a class="jxr_linenumber" name="L144" href="#L144">144</a>       Element _owner_1 = ns.getOwner();
<a class="jxr_linenumber" name="L145" href="#L145">145</a>       <strong class="jxr_keyword">return</strong> JavaClassImportDeclaration.getPackagedClassifier(_owner_1);
<a class="jxr_linenumber" name="L146" href="#L146">146</a>     }
<a class="jxr_linenumber" name="L147" href="#L147">147</a>   }
<a class="jxr_linenumber" name="L148" href="#L148">148</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
